"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRoot = createRoot;

function _asyncToGenerator2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function () {
    return data;
  };

  return data;
}

function _string() {
  const data = require("@teambit/string.to-windows-compatible-path");

  _string = function () {
    return data;
  };

  return data;
}

function _lodash() {
  const data = require("lodash");

  _lodash = function () {
    return data;
  };

  return data;
}

function _path() {
  const data = require("path");

  _path = function () {
    return data;
  };

  return data;
}

function _ui() {
  const data = require("./ui.aspect");

  _ui = function () {
    return data;
  };

  return data;
}

function createRoot(_x, _x2) {
  return _createRoot.apply(this, arguments);
}

function _createRoot() {
  _createRoot = (0, _asyncToGenerator2().default)(function* (aspectDefs, rootExtensionName, rootAspect = _ui().UIAspect.id, runtime = 'ui') {
    const rootId = rootExtensionName ? `'${rootExtensionName}'` : '';
    const defs = aspectDefs.filter(def => def.runtimePath);
    return `
import { Harmony } from '@teambit/harmony';
${getImportStatements(aspectDefs.map(def => def.aspectPath), 'Aspect')} 
${getImportStatements( // @ts-ignore no nulls can be found here - see above.
    defs.map(def => def.runtimePath), 'Runtime')}

Harmony.load([${getIdentifiers(aspectDefs.map(def => def.aspectPath), 'Aspect')}], '${runtime}', {})
  .then((harmony) => {
    harmony
      .run()
      .then(() => {
        const rootExtension = harmony.get('${rootAspect}');
        rootExtension.render(${rootId});
      })
      .catch((err) => {
        throw err;
      });
  });
  `;
  });
  return _createRoot.apply(this, arguments);
}

function getImportStatements(extensionPaths, suffix) {
  return extensionPaths.map(path => `import ${getIdentifier(path, suffix)} from '${(0, _string().toWindowsCompatiblePath)(path)}';`).join('\n');
}

function getIdentifiers(extensionsPaths, suffix) {
  return extensionsPaths.map(path => `${getIdentifier(path, suffix)}`).join(', ');
}

function getIdentifier(path, suffix) {
  return (0, _lodash().camelCase)(`${(0, _path().parse)(path).name.split('.')[0]}${suffix}`);
}

//# sourceMappingURL=create-root.js.map