"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StartCmd = void 0;

function _asyncToGenerator2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _workspace() {
  const data = require("@teambit/workspace");

  _workspace = function () {
    return data;
  };

  return data;
}

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function () {
    return data;
  };

  return data;
}

function _cliOutput() {
  const data = require("./cli-output");

  _cliOutput = function () {
    return data;
  };

  return data;
}

function _outputTemplates() {
  const data = require("./output-templates");

  _outputTemplates = function () {
    return data;
  };

  return data;
}

function _report() {
  const data = require("./report");

  _report = function () {
    return data;
  };

  return data;
}

class StartCmd {
  constructor(ui, logger, pubsub) {
    this.ui = ui;
    this.logger = logger;
    this.pubsub = pubsub;
    (0, _defineProperty2().default)(this, "startingtimestamp", void 0);
    (0, _defineProperty2().default)(this, "name", 'start [type] [pattern]');
    (0, _defineProperty2().default)(this, "description", 'Start a dev environment for a workspace or a specific component');
    (0, _defineProperty2().default)(this, "alias", 'c');
    (0, _defineProperty2().default)(this, "group", 'component');
    (0, _defineProperty2().default)(this, "shortDescription", '');
    (0, _defineProperty2().default)(this, "options", [['d', 'dev', 'start UI server in dev mode.'], ['p', 'port', 'port of the UI server.'], ['r', 'rebuild', 'rebuild the UI'], ['v', 'verbose', 'showing verbose output for inspection and prints stack trace'], ['', 'suppress-browser-launch', 'do not automatically open browser when ready']]);
  }

  report([uiRootName, userPattern], {
    dev,
    port,
    rebuild
  }) {
    var _this = this;

    return (0, _asyncToGenerator2().default)(function* () {
      return (0, _report().report)([uiRootName, userPattern], {
        dev,
        port,
        rebuild
      }, _this.ui, _this.logger, _this.pubsub);
    })();
  }

  render([uiRootName, userPattern], {
    dev,
    port,
    rebuild,
    verbose,
    suppressBrowserLaunch
  }) {
    var _this2 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      _this2.startingtimestamp = Date.now();
      const pattern = userPattern && userPattern.toString();

      _this2.logger.off();

      _this2.ui.createRuntime({
        uiRootName,
        pattern,
        dev,
        port: port ? parseInt(port) : undefined,
        rebuild
      });

      return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, /*#__PURE__*/_react().default.createElement(_outputTemplates().ClearConsole, {
        verbose: !!verbose
      }), /*#__PURE__*/_react().default.createElement(_cliOutput().CliOutput, {
        workspaceID: _workspace().WorkspaceAspect.id,
        startingTimestamp: Date.now(),
        pubsub: _this2.pubsub,
        commandFlags: {
          dev: !!dev,
          port,
          verbose: !!verbose,
          suppressBrowserLaunch: !!suppressBrowserLaunch
        }
      }));
    })();
  }

}

exports.StartCmd = StartCmd;

//# sourceMappingURL=start.cmd/index.js.map