"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.sort");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UiMain = void 0;

function _asyncToGenerator2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _cache() {
  const data = require("@teambit/cache");

  _cache = function () {
    return data;
  };

  return data;
}

function _cli() {
  const data = require("@teambit/cli");

  _cli = function () {
    return data;
  };

  return data;
}

function _component() {
  const data = require("@teambit/component");

  _component = function () {
    return data;
  };

  return data;
}

function _express() {
  const data = require("@teambit/express");

  _express = function () {
    return data;
  };

  return data;
}

function _graphql() {
  const data = require("@teambit/graphql");

  _graphql = function () {
    return data;
  };

  return data;
}

function _harmony() {
  const data = require("@teambit/harmony");

  _harmony = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = require("@teambit/logger");

  _logger = function () {
    return data;
  };

  return data;
}

function _pubsub() {
  const data = _interopRequireDefault(require("@teambit/pubsub"));

  _pubsub = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("bit-bin/dist/utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _getPort() {
  const data = _interopRequireDefault(require("get-port"));

  _getPort = function () {
    return data;
  };

  return data;
}

function _path() {
  const data = require("path");

  _path = function () {
    return data;
  };

  return data;
}

function _util() {
  const data = require("util");

  _util = function () {
    return data;
  };

  return data;
}

function _webpack() {
  const data = _interopRequireDefault(require("webpack"));

  _webpack = function () {
    return data;
  };

  return data;
}

function _events() {
  const data = require("./events");

  _events = function () {
    return data;
  };

  return data;
}

function _createRoot() {
  const data = require("./create-root");

  _createRoot = function () {
    return data;
  };

  return data;
}

function _exceptions() {
  const data = require("./exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

function _start() {
  const data = require("./start.cmd");

  _start = function () {
    return data;
  };

  return data;
}

function _uiBuild() {
  const data = require("./ui-build.cmd");

  _uiBuild = function () {
    return data;
  };

  return data;
}

function _uiServer() {
  const data = require("./ui-server");

  _uiServer = function () {
    return data;
  };

  return data;
}

function _ui() {
  const data = require("./ui.aspect");

  _ui = function () {
    return data;
  };

  return data;
}

function _openBrowser() {
  const data = require("./open-browser");

  _openBrowser = function () {
    return data;
  };

  return data;
}

function _webpack2() {
  const data = _interopRequireDefault(require("./webpack/webpack.config"));

  _webpack2 = function () {
    return data;
  };

  return data;
}

class UiMain {
  constructor(pubsub, config, graphql, uiRootSlot, express, onStartSlot, componentExtension, cache, logger) {
    this.pubsub = pubsub;
    this.config = config;
    this.graphql = graphql;
    this.uiRootSlot = uiRootSlot;
    this.express = express;
    this.onStartSlot = onStartSlot;
    this.componentExtension = componentExtension;
    this.cache = cache;
    this.logger = logger;
    (0, _defineProperty2().default)(this, "createUiServerStartedEvent", (targetHost, targetPort, uiRoot) => {
      return new (_events().UiServerStartedEvent)(Date.now(), targetHost, targetPort, uiRoot);
    });
  }
  /**
   * create a build of the given UI root.
   */


  build(uiRootName) {
    var _this = this;

    return (0, _asyncToGenerator2().default)(function* () {
      const [name, uiRoot] = _this.getUi(uiRootName); // TODO: @uri refactor all dev server related code to use the bundler extension instead.


      const config = (0, _webpack2().default)(uiRoot.path, [yield _this.generateRoot(yield uiRoot.resolveAspects(_ui().UIRuntime.name), name)], uiRoot.name);
      const compiler = (0, _webpack().default)(config);
      const compilerRun = (0, _util().promisify)(compiler.run.bind(compiler));
      return compilerRun();
    })();
  }
  /**
   * create a Bit UI runtime.
   */


  createRuntime({
    uiRootName,
    pattern,
    dev,
    port,
    rebuild
  }) {
    var _this2 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      const [name, uiRoot] = _this2.getUi(uiRootName);

      _this2.componentExtension.setHostPriority(name);

      const uiServer = _uiServer().UIServer.create({
        express: _this2.express,
        graphql: _this2.graphql,
        uiRoot,
        uiRootExtension: name,
        ui: _this2,
        logger: _this2.logger
      });

      const targetPort = yield _this2.getPort(port);

      if (dev) {
        yield uiServer.dev({
          port: targetPort
        });
      } else {
        yield _this2.buildIfChanged(name, uiRoot, rebuild);
        yield _this2.buildIfNoBundle(name, uiRoot);
        yield uiServer.start({
          port: targetPort
        });
      } // TODO: is this the right place?


      _this2.pubsub.pub(_ui().UIAspect.id, _this2.createUiServerStartedEvent(_this2.config.host, targetPort, uiRoot));

      if (uiRoot.postStart) yield uiRoot.postStart({
        pattern
      });
      yield _this2.invokeOnStart(); // TODO: need to wait until compilation done, then open browser
      // await this.openBrowser(`http://${this.config.host}:${targetPort}`);

      return uiServer;
    })();
  }

  getPort(port) {
    var _this3 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      if (port) return port;
      return _this3.config.port || _this3.selectPort();
    })();
  }
  /**
   * Events
   */


  /**
   * bind to ui server start event.
   */
  registerOnStart(onStartFn) {
    this.onStartSlot.register(onStartFn);
    return this;
  }

  invokeOnStart() {
    var _this4 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      const promises = _this4.onStartSlot.values().map(fn => fn());

      yield Promise.all(promises);
    })();
  }
  /**
   * register a UI slot.
   */


  registerUiRoot(uiRoot) {
    return this.uiRootSlot.register(uiRoot);
  }
  /**
   * get a UI runtime instance.
   */


  getUi(uiRootName) {
    if (uiRootName) {
      const root = this.getUiRootOrThrow(uiRootName);
      return [uiRootName, root];
    }

    const uis = this.uiRootSlot.toArray();
    if (uis.length === 1) return uis[0];
    const uiRoot = uis.find(([, root]) => root.priority);
    if (!uiRoot) throw new (_exceptions().UnknownUI)('default');
    return uiRoot;
  }

  getUiRootOrThrow(uiRootName) {
    const uiSlot = this.uiRootSlot.get(uiRootName);
    if (!uiSlot) throw new (_exceptions().UnknownUI)(uiRootName);
    return uiSlot;
  }

  createLink(aspectDefs, rootExtensionName) {
    return (0, _createRoot().createRoot)(aspectDefs, rootExtensionName);
  }
  /**
   * generate the root file of the UI runtime.
   */


  generateRoot(aspectDefs, rootExtensionName, runtimeName = _ui().UIRuntime.name, rootAspect = _ui().UIAspect.id) {
    return (0, _asyncToGenerator2().default)(function* () {
      const contents = yield (0, _createRoot().createRoot)(aspectDefs, rootExtensionName, rootAspect, runtimeName);
      const filepath = (0, _path().resolve)((0, _path().join)(__dirname, `${runtimeName}.root${(0, _utils().sha1)(contents)}.js`));
      if (_fsExtra().default.existsSync(filepath)) return filepath;

      _fsExtra().default.outputFileSync(filepath, contents);

      return filepath;
    })();
  }

  selectPort() {
    var _this5 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      const [from, to] = _this5.config.portRange;
      return (0, _getPort().default)({
        port: _getPort().default.makeRange(from, to)
      });
    })();
  }

  buildUiHash(uiRoot, runtime = 'ui') {
    return (0, _asyncToGenerator2().default)(function* () {
      const aspects = yield uiRoot.resolveAspects(runtime);
      aspects.sort((a, b) => a.aspectPath > b.aspectPath ? 1 : -1);
      const hash = aspects.map(aspect => {
        return [aspect.aspectPath, aspect.runtimePath].join('');
      });
      return (0, _utils().sha1)(hash.join(''));
    })();
  }

  buildIfChanged(name, uiRoot, force) {
    var _this6 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      const hash = yield _this6.buildUiHash(uiRoot);
      const hashed = yield _this6.cache.get(uiRoot.path);
      if (hash === hashed && !force) return;
      if (hash !== hashed) _this6.logger.console(`${uiRoot.configFile} has been changed. Rebuilding UI assets for ${uiRoot.name}`);

      _this6.logger.console(`Building UI assets for ${uiRoot.name}`);

      yield _this6.build(name);
      yield _this6.cache.set(uiRoot.path, hash);
    })();
  }

  buildIfNoBundle(name, uiRoot) {
    var _this7 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      const config = (0, _webpack2().default)(uiRoot.path, [yield _this7.generateRoot(yield uiRoot.resolveAspects(_ui().UIRuntime.name), name)], uiRoot.name);
      if (_fsExtra().default.pathExistsSync(config.output.path)) return;
      if (_fsExtra().default.readdirSync(config.output.path).length > 0) return;
      const hash = yield _this7.buildUiHash(uiRoot);
      yield _this7.build(name);
      yield _this7.cache.set(uiRoot.path, hash);
    })();
  }

  openBrowser(url) {
    var _this8 = this;

    return (0, _asyncToGenerator2().default)(function* () {
      const openBrowser = new (_openBrowser().OpenBrowser)(_this8.logger);
      openBrowser.open(url);
    })();
  }

  static provider([pubsub, cli, graphql, express, componentExtension, cache, loggerMain], config, [uiRootSlot, onStartSlot]) {
    return (0, _asyncToGenerator2().default)(function* () {
      // aspectExtension.registerRuntime(new RuntimeDefinition('ui', []))
      const logger = loggerMain.createLogger(_ui().UIAspect.id);
      const ui = new UiMain(pubsub, config, graphql, uiRootSlot, express, onStartSlot, componentExtension, cache, logger);
      cli.register(new (_start().StartCmd)(ui, logger, pubsub));
      cli.register(new (_uiBuild().UIBuildCmd)(ui));
      return ui;
    })();
  }

}

exports.UiMain = UiMain;
(0, _defineProperty2().default)(UiMain, "defaultConfig", {
  portRange: [3000, 3100],
  host: 'localhost'
});
(0, _defineProperty2().default)(UiMain, "runtime", _cli().MainRuntime);
(0, _defineProperty2().default)(UiMain, "dependencies", [_pubsub().default, _cli().CLIAspect, _graphql().GraphqlAspect, _express().ExpressAspect, _component().ComponentAspect, _cache().CacheAspect, _logger().LoggerAspect]);
(0, _defineProperty2().default)(UiMain, "slots", [_harmony().Slot.withType(), _harmony().Slot.withType()]);

_ui().UIAspect.addRuntime(UiMain);

//# sourceMappingURL=ui.main.runtime.js.map